<?php
class PasswordModel extends Model
{
	private $table_name = "tbl_users";

	public function Index()
	{
		$out = array("title" => "Password", "version" => 1);
		return $out;
	}

	public function change()
	{		
		try
		{
			$eml = null;
			$old = null;
			$new = null;
			$json = file_get_contents("php://input");
			$Map1 = array();
			$Map1 = json_decode($json, true);
			if (empty($Map1))
			{
				$msg_text = "[Value Not Set]";
				$this->LogUser("password/change", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;				
			}
			if (!array_key_exists("eml", $Map1) || !array_key_exists("old", $Map1) || !array_key_exists("new", $Map1))
			{
				$msg_text = "[Value Not Set]";
				$this->LogUser("password/change", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;
			}
			$eml = $Map1["eml"];
			$old = $Map1["old"];
			$new = $Map1["new"];
			if ($eml == "" || $old == "" || $new == "")
			{
				$msg_text = "[Value Not Set]";
				$this->LogUser("password/change", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;
			}
			if ($old == $new) 
			{
				$msg_text = "[Same Password]";
				$this->LogUser("password/change", "fail", $msg_text, 0);
				$this->ReturnError("Error-Same-Value");
				return;
			}

			// Find user
			$sql = "SELECT";
			$sql .= " user_id AS `result`,";
			$sql .= " 'success' AS `message`,";
			$sql .= " user_email,";
			$sql .= " user_name";
			$sql .= " FROM ".$this->table_name;
			$sql .= " WHERE user_email = :email";
			$sql .= " AND user_hash = md5(concat(:password, user_salt))";
			$this->query($sql);
			$this->bind(":email", $eml);
			$this->bind(":password", $old);
			$row = $this->single();
			if ($row)
			{
				// $user_id = $row["result"];
				$salt = mt_rand(100001, 999999);
				$salt = md5($salt);
				$hash = md5($new.$salt);
				// Update User Password
				$sql = "UPDATE";
				$sql .= " tbl_users SET";
				$sql .= " user_salt = :salt,";
				$sql .= " user_hash = :hash";
				$sql .= " WHERE user_email = :eml";
				$sql .= " AND user_hash = md5(concat(:old, user_salt))";
				$this->query($sql);
				$this->bind(":salt", $salt);
				$this->bind(":hash", $hash);
				$this->bind(":eml", $eml);
				$this->bind(":old", $old);
				$this->execute();
				// Send email
				$this->SendEmail($row["user_name"], $row["user_email"], "change", "null", "null");
				// Return success
				// $msg_text = $eml;
				// $this->LogUser("password/change", "success", $msg_text, $user_id);
				// $this->ReturnSuccess("success");
				return;
			}
			else
			{
				$msg_text = "[Not Found] ".$eml;
				$this->LogUser("password/change", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Result");
				return;
			}
		}
		catch (PDOException $e)
		{
			$msg_text = "[Exception] ".$e->getMessage();
			$this->LogError("password/change", $msg_text);
			$this->ReturnError("Error-Execute-Query");
			return;
		}		
	}

	public function reset()
	{
		try
		{				
			$eml = null;
			$json = file_get_contents("php://input");
			$Map1 = array();
			$Map1 = json_decode($json, true);
			if (empty($Map1))
			{
				$msg_text = "[Email Not Set]";
				$this->LogUser("password/reset", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;				
			}
			if (!array_key_exists("eml", $Map1))
			{
				$msg_text = "[Email Not Set]";
				$this->LogUser("password/reset", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;
			}
			$eml = $Map1["eml"];
			if ($eml == "")
			{
				$msg_text = "[Email Not Set]";
				$this->LogUser("password/reset", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;
			}			
			// Find user
			$sql = "SELECT";
			$sql .= " user_id AS `result`,";
			$sql .= " 'success' AS `message`,";
			$sql .= " user_email,";
			$sql .= " user_name";
			$sql .= " FROM ".$this->table_name;
			$sql .= " WHERE user_email = :eml";
			$this->query($sql);
			$this->bind(":eml", $eml);
			$row = $this->single();
			if ($row)
			{
				// $user_id = $row["result"];
				// Update activation code
				$code = mt_rand(100000, 999999);
				$code = md5($code);
				$sql = "UPDATE ".$this->table_name." SET";
				$sql .= " user_activation_code = :code";
				$sql .= " WHERE user_email = :eml";
				$this->query($sql);
				$this->bind(":code", $code);
				$this->bind(":eml", $eml);
				$this->execute();
				// Send email
				$this->SendEmail($row["user_name"], $row["user_email"], "reset", $code, "null");
				return;
			}
			else
			{
				$msg_text = "[Not Found] ".$eml;
				$this->LogUser("password/reset", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Result");
				return;
			}
		}
		catch (PDOException $e)
		{
			$msg_text = "[Exception] ".$e->getMessage();
			$this->LogError("password/reset", $msg_text);
			$this->ReturnError("Error-Execute-Query");
			return;
		}	
	}

	public function confirmreset($code)
	{
		try
		{
			if ($code == "")
			{
				$msg_text = "[Code Not Set]";
				$this->LogUser("password/confirmreset", "fail", $msg_text, 0);
				//$this->ReturnError("Error-No-Value");
				$html = "<h1>Reset Password</h1>
				<p>Invalid reset code!</p>";
				echo $html;
				return;
			}
			// Find user
			$sql = "SELECT";
			// $sql .= " user_id AS `result`,";
			// $sql .= " 'success' AS `message`,";			
			$sql .= " user_name,";
			$sql .= " user_email";
			$sql .= " FROM ".$this->table_name;
			$sql .= " WHERE user_activation_code = :code";
			$this->query($sql);
			$this->bind(":code", $code);
			$row = $this->single();
			if ($row)
			{
				// $user_id = $row["result"];
				// You may use other method to generate a more complex password with alphanumeric
				$tmp_pwd = md5(mt_rand(100001, 999999));
	            $tmp_pwd = substr($tmp_pwd, -8); // get last 8 letters
	            $salt = md5(mt_rand(100001, 999999));
	            $hash = md5($tmp_pwd.$salt);
	            $code = md5($hash);

				// Update user hash and salt, and also set new activation code so user cannot reset again using same code
	            $sql = "UPDATE ".$this->table_name." SET";
	            $sql .= " user_hash = :hash,";
	            $sql .= " user_salt = :salt,";
	            $sql .= " user_activation_code = :code,";
	            $sql .= " modified_at = now()";
	            $sql .= " WHERE user_email = :eml";
	            $this->query($sql);
	            $this->bind(":hash", $hash);
	            $this->bind(":salt", $salt);
	            $this->bind(":code", $code);
	            $this->bind(":eml", $row["user_email"]);
	            $this->execute();
				// Send email
	            $this->SendEmail($row["user_name"], $row["user_email"], "confirmreset", "null", $tmp_pwd);
	            return;
	        }
	        else
	        {
	        	$msg_text = "[Not Found] ".$code;
	        	$this->LogUser("password/confirmreset", "fail", $msg_text, 0);
	        	// $this->ReturnError("Error-No-Result");
				$html = "<h1>Reset Password</h1>
				<p>Invalid reset code!</p>";
				echo $html;	        	
	        	return;
	        }			
	    }
	    catch (PDOException $e)
	    {
	    	$msg_text = "[Exception] ".$e->getMessage();
	    	$this->LogError("password/confirmreset", $msg_text);
	    	// $this->ReturnError("Error-Execute-Query");
	    	$html = "<h1>Reset Password</h1>
			<p>An error occured!</p>";
			echo $html;
	    	return;
	    }
	}

	private function ReturnError($Message)
	{
		if ($Message == "") $Message = "failed";
		$out = array("result" => -1, "message" => $Message);
		print json_encode(array($out));
	}

	private function ReturnSuccess($Message)
	{
		if ($Message == "") $Message = "success";
		$out = array("result" => 0, "message" => $Message);
		print json_encode(array($out));
	}

	private function LogError($Sub, $Message)
	{
		$sql = "INSERT INTO tbl_error";
		$sql .= " (error_text)";
		$sql .= " SELECT :message";
		$this->query($sql);
		$this->bind(":message", "[$Sub] $Message");
		$this->execute();
	}

	private function LogUser($log_view, $log_type, $log_text, $log_user)
	{
		try 
		{
			$sql = "INSERT INTO tbl_users_log";
			$sql .= " (log_view,";
			$sql .= " log_type,";
			$sql .= " log_text,";
			$sql .= " log_user)";
			$sql .= " VALUES";
			$sql .= " (:log_view,";
			$sql .= " :log_type,";
			$sql .= " :log_text,";
			$sql .= " :log_user)";
			$this->query($sql);
			$this->bind(":log_view", $log_view);
			$this->bind(":log_type", $log_type);
			$this->bind(":log_text", $log_text);
			$this->bind(":log_user", $log_user);
			$this->execute();
		}
		catch (PDOException $e)
		{
			$msg_text = "[Exception] ".$e->getMessage();
			$this->LogError("LogUser", $msg_text);
			$this->ReturnError("Error-Execute-Query");
		}		
	}

	private function SendEmail($user_name, $user_email, $action, $reset_code, $temp_password)
	{
		// Email header
		$headers = "From: ".NOREPLY_EMAIL."\r\n";
		$headers .= "Reply-To: ".NOREPLY_EMAIL."\r\n";
		$headers .= "X-Mailer: PHP/".phpversion();
		try
		{
			switch ($action)
			{
				case "change":
					// $subject = APP_TRADEMARK;
					$subject = "Your password has been changed";
					$body = "Hi $user_name,\r\n";
					$body .= "We have noticed that you have changed your password recently.\r\n";
					$body .= "If this action is not initiated by you, please contact us.\r\n";
					$body .= "Otherwise, please ignore this email.\r\n\r\n";
					$body .= "Regards,\r\n";
					$body .= APP_TRADEMARK;
					$body = wordwrap($body, 70, "\r\n");
					mail($user_email, $subject, $body, $headers);
					break;
				case "reset":
					// $subject = APP_TRADEMARK;
					$subject = "Request to reset your password";
					$body = "Hi $user_name,\r\n";
					$body .= "We have received a request from you to reset your password.\r\n\r\n";
					$body .= "If this action is not initiated by you, please contact us.\r\n";
					$body .= "Otherwise, click the following link to confirm:\r\n";
					$body .= ROOT_URL."/password/confirmreset/".$reset_code."\r\n\r\n";					
					$body .= "If you have changed your mind, just ignore this email.\r\n";
					$body .= "If the link is not working, please copy the url to your browser.\r\n\r\n";
					$body .= "Regards,\r\n";
					$body .= APP_TRADEMARK;
					$body = wordwrap($body, 70, "\r\n");
					mail($user_email, $subject, $body, $headers);

		        	// Notify site admin of request to change password
					// $admin_email = ADMIN_EMAIL;
					// $subject = "Reset Password";
					// $body = $user_name." has requested to change his/her password.";
					// mail($admin_email, $subject, $body, $headers);
					break;
				case "confirmreset":
					// $subject = APP_TRADEMARK;
					$subject = "Your password has been reset";
					$body = "Hi $user_name,\r\n";
					$body .= "Your password has been reset.\r\n";
					$body .= "Please use the following temporary password to log in.\r\n";		            
					$body .= "Password: ".$temp_password."\r\n\r\n";
					$body .= "Once you are able to log in, please change to a new password.\r\n\r\n";
					$body .= "Regards,\r\n";
					$body .= APP_TRADEMARK;
					$body = wordwrap($body, 70, "\r\n");
					mail($user_email, $subject, $body, $headers);

		        	// Notify site admin of password changed
					// $admin_email = ADMIN_EMAIL;
					// $subject = "Reset password";
					// $body = $user_name." has confirmed to change his/her password.";
					// mail($admin_email, $subject, $body, $headers);
					break;
				default:
					$msg_text = "[Unknown Action] ".$user_email;
					$this->LogUser("password->SendEmail", "fail", $msg_text, 0);
					// $this->ReturnError("Error-Unknown-Action");
					$html = "<h1>Confirm Reset Password</h1>
					<p>Unrecognized action!</p>";
					echo $html;
					return;
			}
			// Return success
			$msg_text = "[SendEmail] ".$user_email;
			$this->LogUser("password/".$action, "success", $msg_text, 0);
			// $this->ReturnSuccess("success");
			switch ($action)
			{
				case "change":
					// $html = "<h1>Change Password</h1>";
					// $html .= "<p>Confirmation email has been sent!</p>";
					// echo $html;
					$this->ReturnSuccess("success");
					break;
				case "reset":
					// $html = "<h1>Reset Password</h1>";
					// $html .= "<p>Confirmation email has been sent!</p>";
					// echo $html;
					$this->ReturnSuccess("success");
					break;
				case "confirmreset":
					$html = "<h1>Confirm Reset Password</h1>";
					$html .= "<p>Password reset successfully.<br/>Please check your email for temporary password.</p>";
					echo $html;
					break;
			}			
		}
		catch (Exception $e)
		{        
			$msg_text = "[Exception] ".$e->getMessage();
			$this->LogError("SendEmail", $msg_text);
			$this->ReturnError("Error-Send-Email");
		}
	}
}