<?php
class UserModel extends Model
{
	private $table_name = "tbl_users";

	public function Index()
	{
		$out = array("title" => "User", "version" => 1);
		return $out;
	}	

	public function connect()
	{
		$out = array("Connected" => 1);
		print json_encode(array($out));
	}

	private function ReturnError($Message)
	{
		if ($Message == "") $Message = "failed";
		$out = array("result" => -1, "message" => $Message);
		print json_encode(array($out));
	}

	private function ReturnSuccess($Message)
	{
		if ($Message == "") $Message = "success";
		$out = array("result" => 0, "message" => $Message);
		print json_encode(array($out));
	}

	private function LogError($Sub, $Message)
	{
		$sql = "INSERT INTO tbl_error";
		$sql .= " (error_text)";
		$sql .= " SELECT :message";
		$this->query($sql);
		$this->bind(":message", "[$Sub] $Message");
		$this->execute();
	}

	private function LogUser($log_view, $log_type, $log_text, $log_user)
	{
		try 
		{
			$sql = "INSERT INTO tbl_users_log";
			$sql .= " (log_view,";
			$sql .= " log_type,";
			$sql .= " log_text,";
			$sql .= " log_user)";
			$sql .= " VALUES";
			$sql .= " (:log_view,";
			$sql .= " :log_type,";
			$sql .= " :log_text,";
			$sql .= " :log_user)";
			$this->query($sql);
			$this->bind(":log_view", $log_view);
			$this->bind(":log_type", $log_type);
			$this->bind(":log_text", $log_text);
			$this->bind(":log_user", $log_user);
			$this->execute();
		}
		catch (PDOException $e)
		{
			$msg_text = "[Exception] ".$e->getMessage();
			$this->LogError("LogUser", $msg_text);
			$this->ReturnError("Error-Execute-Query");
		}
	}
	
	public function register()
	{
		try 
		{			
			$eml = null;
			$pwd = null;
			$name = null;
			$json = file_get_contents("php://input");

			$Map1 = array();	
			$Map1 = json_decode($json, true);
			if (!array_key_exists("eml", $Map1))
			{
				$msg_text = "[Email Not Set]";
				$this->LogUser("user/register", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;
			}
			if (!array_key_exists("pwd", $Map1))
			{
				$msg_text = "[Password Not Set]";
				$this->LogUser("user/register", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;
			}
			if (!array_key_exists("name", $Map1))
			{
				$msg_text = "[Name Not Set]";
				$this->LogUser("user/register", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;
			}
			$eml = $Map1["eml"];
			$pwd = $Map1["pwd"];
			$name = $Map1["name"];
			if ($eml == "" || $pwd == "" || $name == "") 
			{
				$msg_text = "[Not Set]";
				$this->LogUser("user/register", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;
			}

			$sql = "SELECT";
			$sql .= " user_id AS `result`";
			$sql .= " FROM ".$this->table_name;
			$sql .= " WHERE user_email = :eml";
			$this->query($sql);
			$this->bind(":eml", $eml);
			$row = $this->single();
			if ($row) {
				$msg_text = "[Email Used] ".$eml;
				$this->LogUser("user/register", "fail", $msg_text, $row["result"]);
				$this->ReturnError("Error-Email-Used");
				return;
			}
			else {
				$salt = mt_rand(100001, 999999);
				$salt = md5($salt);
				$hash = md5($pwd.$salt);
				$code = md5($salt.$eml);
				$flag = "M";
				$sql = "INSERT INTO ".$this->table_name;
				$sql .= " (user_email,";
				$sql .= " user_name,";
				$sql .= " user_hash,";
				$sql .= " user_salt,";
				$sql .= " user_activation_code,";
				$sql .= " user_activation_flag)";
				$sql .= " VALUES";
				$sql .= " (:eml,";
				$sql .= " :name,";
				$sql .= " :hash,";
				$sql .= " :salt,";
				$sql .= " :code,";
				$sql .= " :flag)";
				$this->query($sql);
				$this->bind(":eml", $eml);
				$this->bind(":name", $name);
				$this->bind(":hash", $hash);
				$this->bind(":salt", $salt);
				$this->bind(":code", $code);
				$this->bind(":flag", $flag);
				$this->execute();
				$user_id = $this->lastInsertId();
				$msg_text = "new user";
				$this->LogUser("user/register", "success", $msg_text, $user_id);
				$this->SendEmail($name, $eml, $code);
				$this->ReturnSuccess("success");
				return;
			}
		}
		catch (PDOException $e)
		{
			$msg_text = "[Exception] ".$e->getMessage();
			$this->LogError("user/register", $msg_text);
			$this->ReturnError("Error-Execute-Query");
		}
	}

	public function activate($code)
	{		
		try
		{
			if ($code == "") 
			{
				$msg_text = "[Not Set]";
				$this->LogUser("user/activate", "fail", $msg_text, 0);
				//$this->ReturnError("Error-No-Value");
				$html = "<h1>Activation</h1>
				<p>Invalid activation code!</p>";
				echo $html;
				return;
			}
			// Dummy Code
			if ($code == "vhbgroalh90akyyypt0ah3qjo5gpb0bx")
			{
				$this->ReturnSuccess("Success-Dummy-Code");
				return;
			}
			// Compare Login
			$sql = "SELECT";
			$sql .= " user_id AS `result`,";
			$sql .= " 'success' AS `message`";
			$sql .= " FROM ".$this->table_name;
			$sql .= " WHERE user_activation_code = :code";
			$sql .= " AND user_activation_flag = 'M'";
			$this->query($sql);
			$this->bind(":code", $code);
			$row = $this->single();
			if ($row) {
				// Update flag
				$sql = "UPDATE";
				$sql .= " ".$this->table_name." SET";
				$sql .= " user_activation_flag = 'R',";
				$sql .= " user_activated_at = now(),";
				$sql .= " user_active = 1";				
				$sql .= " WHERE user_activation_code = :code";
				$sql .= " AND user_activation_flag = 'M'";
				$this->query($sql);
				$this->bind(":code", $code);
				$this->execute();
				// return success
				$msg_text = $code;
				$this->LogUser("user/activate", "success", $msg_text, $row["result"]);
				//$this->ReturnSuccess("success");
				$html = "<h1>Activation</h1>
				<p>Your account is now activated!</p>";
				echo $html;
			}
			else
			{
				$msg_text = "[Not Found] ".$code;
				$this->LogUser("user/activate", "fail", $msg_text, 0);
				//$this->ReturnError("Error-No-Result");
				$html = "<h1>Activation</h1>
				<p>Account not found!</p>";
				echo $html;
			}
		}
		catch (PDOException $e)
		{
			$msg_text = "[Exception] ".$e->getMessage();
			$this->LogError("user/activate", $msg_text);
			//$this->ReturnError("Error-Execute-Query");
			$html = "<h1>Activation</h1>
			<p>An error occured!</p>";
			echo $html;
		}
	}

	public function login()
	{
		try 
		{
			$eml = null;
			$pwd = null;
			$json = file_get_contents("php://input");
			$Map1 = array();
			$Map1 = json_decode($json, true);
			if (!array_key_exists("eml", $Map1))
			{
				$msg_text = "[Key Not Set: Email]";
				$this->LogUser("user/login", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;
			}
			if (!array_key_exists("pwd", $Map1))
			{
				$msg_text = "[Key Not Set: Password]";
				$this->LogUser("user/login", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;
			}
			$eml = $Map1["eml"];
			$pwd = $Map1["pwd"];
			if ($eml == "" || $pwd == "") 
			{
				$msg_text = "[Not Set]";
				$this->LogUser("user/login", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;
			}
			// Get user data
			$sql = "SELECT";
			$sql .= " user_id AS `result`,";
			$sql .= " 'success' AS `message`,";
			$sql .= " user_name,";
			$sql .= " user_email,";
			$sql .= " ifnull(user_location, '') AS user_location,";
			$sql .= " ifnull(user_api_key, '') AS user_api_key,";
			$sql .= " user_activation_flag";
			$sql .= " FROM ".$this->table_name;
			$sql .= " WHERE user_email = :email";
			$sql .= " AND user_hash = md5(concat(:password, user_salt))";
			$this->query($sql);
			$this->bind(":email", $eml);
			$this->bind(":password", $pwd);
			$row = $this->single();
			if ($row)
			{
				// User must activate account through link from email
				if ($row["user_activation_flag"] == "M")
				{
					$msg_text = "[Not Activated] ".$eml;
					$this->LogUser("user/login", "fail", $msg_text, 0);
					$this->ReturnError("Error-Not-Activated");
					return;
				}

				// Update login status
				$sql = "UPDATE ".$this->table_name." SET";
				$sql .= " user_login_count = user_login_count + 1,";
				$sql .= " user_last_login_at = now()";
				$sql .= " WHERE user_email = :eml";
				$this->query($sql);
				$this->bind(":eml", $eml);
				$this->execute();
				// Return success				
				$msg_text = $eml;
				$this->LogUser("user/login", "success", $msg_text, $row["result"]);
				print json_encode(array($row));
				return;
			}
			else
			{
				$msg_text = "[Not Found] ".$eml;
				$this->LogUser("user/login", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Result");
			}
		}
		catch (PDOException $e)
		{
			$msg_text = "[Exception] ".$e->getMessage();
			$this->LogError("user/login", $msg_text);
			$this->ReturnError("Error-Execute-Query");
		}
	}

	private function SendEmail($user_name, $user_email, $activation_code)
	{
		// Email header
		$headers = "From: ".NOREPLY_EMAIL."\r\n";
		$headers .= "Reply-To: ".NOREPLY_EMAIL."\r\n";
		$headers .= "X-Mailer: PHP/".phpversion();

        // Send to new user
		$subject = APP_TRADEMARK;
		$body = "Hi $user_name,\r\n";
		$body .= "Please click on this link to finish the registration process:\r\n";
		$body .= " ".ROOT_URL."/user/activate/".$activation_code;
		$body = wordwrap($body, 70, "\r\n");
		mail($user_email, $subject, $body, $headers);

        // Notify site admin of new sign up
		$admin_email = ADMIN_EMAIL;
		$subject = "New registration";
		$body = $user_name." has registered using our app.";
		mail($admin_email, $subject, $body, $headers);
	}

	public function getapikey()
	{
		try
		{
			$eml = null;
			$pwd = null;
			$json = file_get_contents("php://input");

			$Map1 = array();	
			$Map1 = json_decode($json, true);
			if (!array_key_exists("eml", $Map1))
			{
				$msg_text = "[Email Not Set]";
				$this->LogUser("user/getapikey", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;
			}
			if (!array_key_exists("pwd", $Map1))
			{
				$msg_text = "[Password Not Set]";
				$this->LogUser("user/getapikey", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;
			}
			$eml = $Map1["eml"];
			$pwd = $Map1["pwd"];
			if ($eml == "" || $pwd == "") 
			{
				$msg_text = "[Not Set]";
				$this->LogUser("user/getapikey", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;
			}
			// Compare Login
			$sql = "SELECT";
			$sql .= " user_id AS `result`,";
			$sql .= " 'success' AS `message`,";
			$sql .= " user_api_key";
			$sql .= " FROM ".$this->table_name;
			$sql .= " WHERE user_email = :eml";
			$sql .= " AND user_hash = md5(concat(:pwd, user_salt))";
			$this->query($sql);
			$this->bind(":eml", $eml);
			$this->bind(":pwd", $pwd);
			$row = $this->single();
			if ($row) 
			{
				$msg_text = "existing key";
				if ($row["user_api_key"] == "")
				{
					$apikey = mt_rand(100001, 999999);
					$apikey = md5($apikey);
					// Update apikey
					$sql = "UPDATE ".$this->table_name." SET";
					$sql .= " user_api_key = :apikey";
					$sql .= " WHERE user_email = :eml";
					$this->query($sql);
					$this->bind(":apikey", $apikey);
					$this->bind(":eml", $eml);
					$this->execute();
					$row = array("result" => $row["result"], "message" => "success", "user_api_key" => $apikey);
					$msg_text = "new key";
				}
				$this->LogUser("user/getapikey", "success", $msg_text, $row["result"]);
				// $this->ReturnSuccess("success");
				print json_encode(array($row));				
				return;
			}
			else
			{
				$msg_text = "[Not Found] ".$eml;
				$this->LogUser("user/getapikey", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Result");
				return;
			}
		}
		catch (PDOException $e)
		{
			$msg_text = "[Exception] ".$e->getMessage();
			$this->LogError("user/login", $msg_text);
			$this->ReturnError("Error-Execute-Query");
		}

	}

	public function view($id)
	{
		try 
		{
			if ($id == "")
			{
				$msg_text = "[ID Not Set]";
				$this->LogUser("user/view", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;
			}
			$key = null;
			$json = file_get_contents("php://input");
			$Map1 = array();	
			$Map1 = json_decode($json, true);
			if (!array_key_exists("key", $Map1))
			{
				$msg_text = "[Key Not Set]";
				$this->LogUser("user/view", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;
			}
			$key = $Map1["key"];
			if ($key == "")
			{
				$msg_text = "[Not Set]";
				$this->LogUser("user/view", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;
			}
			$sql = "SELECT";
			$sql .= " user_id AS `result`,";
			$sql .= " 'success' AS `message`,";
			$sql .= " user_email,";
			$sql .= " user_name,";
			$sql .= " ifnull(user_location, '') AS user_location,";
			$sql .= " CASE";
			$sql .= " WHEN (now()-user_last_login_at < 300) THEN 'Y'";
			$sql .= " ELSE 'N' END AS `online`";
			$sql .= " FROM ".$this->table_name;
			$sql .= " WHERE EXISTS";
			$sql .= " (SELECT user_api_key";
			$sql .= " FROM ".$this->table_name;
			$sql .= " WHERE user_api_key = :key)";
			if ($id == "all")
			{
				$this->query($sql);
				$this->bind(":key", $key);
				$row = $this->resultSet();
			}
			else
			{
				$sql .= " AND user_id = :id";
				$this->query($sql);
				$this->bind(":key", $key);
				$this->bind(":id", $id);
				$row = $this->resultSet();
			}
			if ($row)
			{
				$msg_text = "view(".$id.") ".$key;
				$this->LogUser("user/view", "success", $msg_text, 0);
				print json_encode($row); // return single or multiple rows
			}
			else
			{
				$msg_text = "[Not Found] view(".$id.") ".$key;
				$this->LogUser("user/view", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Result");
			}
		}
		catch (PDOException $e)
		{
			$msg_text = "[Exception] ".$e->getMessage();
			$this->LogError("user/view", $msg_text);
			$this->ReturnError("Error-Execute-Query");
		}
	}

	// only update own profile, edit other users is restricted
	public function update()
	{
		try
		{
			$key = null;
			$user_name = null;
			$user_location = null;
			$json = file_get_contents("php://input");
			$Map1 = array();	
			$Map1 = json_decode($json, true);
			if (!array_key_exists("key", $Map1) ||
				!array_key_exists("user_name", $Map1) ||
				!array_key_exists("user_location", $Map1))
			{
				$msg_text = "[Key Not Set]";
				$this->LogUser("user/update", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;
			}
			$key = $Map1["key"];
			$user_name = $Map1["user_name"];
			$user_location = $Map1["user_location"];
			if ($key == "" ||
				$user_name == "" ||
				$user_location == "")
			{
				$msg_text = "[Not Set]";
				$this->LogUser("user/update", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Value");
				return;
			}
			$sql = "SELECT";
			$sql .= " user_email";
			$sql .= " FROM ".$this->table_name;
			$sql .= " WHERE EXISTS";
			$sql .= " (SELECT user_email";
			$sql .= " FROM ".$this->table_name;
			$sql .= " WHERE user_api_key = :key)";
			$this->query($sql);
			$this->bind(":key", $key);
			$row = $this->single();
			if ($row)
			{
				$sql = "UPDATE";
				$sql .= " ".$this->table_name." SET";
				$sql .= " user_name = :user_name,";
				$sql .= " user_location = :user_location";
				$sql .= " WHERE user_api_key = :key";
				$this->query($sql);
				$this->bind(":user_name", $user_name);
				$this->bind(":user_location", $user_location);
				$this->bind(":key", $key);
				$this->execute();
				$msg_text = "update() ".$key;
				$this->LogUser("user/update", "success", $msg_text, 0);
				$this->ReturnSuccess("success");
			}
			else
			{
				$msg_text = "[Not Found] update() ".$key;
				$this->LogUser("user/update", "fail", $msg_text, 0);
				$this->ReturnError("Error-No-Result");
			}
		}
		catch (PDOException $e)
		{
			$msg_text = "[Exception] ".$e->getMessage();
			$this->LogError("user/update", $msg_text);
			$this->ReturnError("Error-Execute-Query");
		}	
	}
}